/// Files: drivers/net/ethernet/hisilicon/hns3/hns3pf/hclge_tm.c
/// Fix: 04f25edb48c441fc278ecc154c270f16966cbb90
/// Fixes: 848440544b41fbe21f36072ee7dc7c3c59ce62e2

virtual detect

@err_hclge_shaper_para_calc@
identifier ir, shaper_level;
position p;
typedef u32, u8;
@@

hclge_shaper_para_calc(u32 ir, u8 shaper_level, ...)
{
	... when != ir > HCLGE_ETHER_MAX_RATE
*	if (shaper_level >=@p HCLGE_SHAPER_LVL_CNT)
*		return -EINVAL;
	... when != ir > HCLGE_ETHER_MAX_RATE
}

@err_hclge_tm_schd_mode_vnet_base_cfg@
identifier hdev, vport;
position p;
@@

hclge_tm_schd_mode_vnet_base_cfg(struct hclge_vport *vport)
{
	... when != if (vport->vport_id >= HNAE3_MAX_TC) return -EINVAL;
*	hclge_tm_pri_schd_mode_cfg@p(hdev, vport->vport_id)
	...
}

@script:python depends on detect@
p << err_hclge_shaper_para_calc.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-15925')

@script:python depends on detect@
p << err_hclge_tm_schd_mode_vnet_base_cfg.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-15925')


