/// Files: drivers/net/dsa/sja1105/sja1105_spi.c
/// Fix: 68501df92d116b760777a2cfda314789f926476f
/// Fixes: 8aa9ebccae87621d997707e4f25e53fddd7e30e4

virtual detect

@err_static_config_buf_prepare_for_upload@
identifier priv, buf_len, config_buf, rc;
position p;
@@

sja1105_static_config_upload(struct sja1105_private *priv)
{
	...
*	config_buf = kcalloc(buf_len, ...);
	...
	rc = static_config_buf_prepare_for_upload(priv, config_buf, buf_len);
	if (rc < 0) {
		... when != kfree(config_buf);
*		return -EINVAL;@p
	}
	...
}

@err_sja1105_inhibit_tx@
identifier priv, buf_len, config_buf, rc;
position p;
@@

sja1105_static_config_upload(struct sja1105_private *priv)
{
	...
*	config_buf = kcalloc(...);
	...
	rc = sja1105_inhibit_tx(priv, ...);
	if (rc < 0) {
		... when != kfree(config_buf);
*		return -ENXIO;@p
	}
	...
}

@script:python depends on detect@
p << err_static_config_buf_prepare_for_upload.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-18807')

@script:python depends on detect@
p << err_sja1105_inhibit_tx.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2019-18807')

