/// Files: arch/x86/kvm/mmu/mmu.c arch/x86/kvm/mmu.c
/// Fix: 9f46c187e2e680ecd9de7983e4d081c3391acc76
/// Detect-To: eb4b248e152d3ecf189b9d32c04961360dbd938a

virtual detect

@err1@
identifier vcpu, gva, pcid, mmu;
position p;
@@

kvm_mmu_invpcid_gva(struct kvm_vcpu *vcpu, gva_t gva, unsigned long pcid)
{
	...
	if (pcid == kvm_get_active_pcid(vcpu)) {
*		mmu->invlpg@p(vcpu, gva, ...);
		...
	}
	...
}

@err2@
identifier vcpu, gva, pcid, mmu;
position p;
@@

kvm_mmu_invpcid_gva(struct kvm_vcpu *vcpu, gva_t gva, unsigned long pcid)
{
	...
	if (VALID_PAGE(...) &&
		pcid == kvm_get_pcid(vcpu, ...)) {
*		mmu->invlpg@p(vcpu, gva, ...);
		...
	}
	...
}


@script:python depends on detect@
p << err1.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-1789')

@script:python depends on detect@
p << err2.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-1789')
