/// Files: security/integrity/ima/ima_policy.c
/// Fix: 543ce63b664e2c2f9533d089a4664b559c3e6b5b
/// Fixes: 29d3c1c8dfe752c01b7115ecd5a3142b232a38e1

virtual detect

@err@
identifier id;
symbol ima_appraise;
position p;
@@

ima_appraise_signature(enum kernel_read_file_id id)
{
	...
*	if (id >= READING_MAX_ID)
*		return false;@p

	... when != if (id == READING_KEXEC_IMAGE && !(ima_appraise & IMA_APPRAISE_ENFORCE) && security_locked_down(LOCKDOWN_KEXEC)) return false;
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-21505')
