/// Files: net/sched/cls_u32.c
/// Fix: 3db09e762dc79584a69c10d74a6b98f89a9979f8
/// Fixes: 35c55fc156d85a396a975fc17636f560fc02fd65

virtual detect

@err_destroy@
identifier n;
position p;
@@

u32_destroy_key(..., struct tc_u_knode *n, ...)
{
	...
	tcf_exts_destroy(&n->exts);
*	tcf_exts_put_net@p(&n->exts);
	...
}

@err_change depends on err_destroy@
position p;
@@

u32_change(...)
{
	...
*	u32_destroy_key@p(...);
	...
}

@script:python depends on detect@
p1 << err_destroy.p;
p2 << err_change.p;
@@

coccilib.report.print_report(p1[0], 'ERROR: CVE-2022-29581')
coccilib.report.print_report(p2[0], 'ERROR: CVE-2022-29581')
