/// Files: fs/jfs/inode.c fs/jfs/jfs_imap.c
/// Fix: a53046291020ec41e09181396c1e829287b48d47
/// Detect-To: v2.6.12-rc2

virtual detect

@diFree@
identifier ip, ipimap, imap;
@@

int diFree(struct inode *ip)
{
	...
*	struct inode *ipimap = JFS_SBI(ip->i_sb)->ipimap;
	...
*	struct inomap *imap = JFS_IP(ipimap)->i_imap;
	...
}

@err depends on diFree@
identifier inode, ipimap;
position p;
@@

\(jfs_delete_inode\|jfs_evict_inode\)(struct inode *inode)
{
	... when != JFS_IP(ipimap)->i_imap
*	diFree@p(inode);
	...
}

@script:python depends on detect@
p << err.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-3202')
