/// Files: net/mac80211/rx.c
/// Fix: b2d03cabe2b2e150ff5a381731ea0355459be09f
/// Fixes: 9eaf183af741e3d8393eb571ac8aec9ee7d6530e

virtual detect

@err_mmie_keyidx@
identifier rx, mmie_keyidx;
position p;
@@

ieee80211_rx_h_decrypt(struct ieee80211_rx_data *rx)
{
	...
	if (mmie_keyidx < NUM_DEFAULT_KEYS + NUM_DEFAULT_MGMT_KEYS ||
 	    mmie_keyidx >= NUM_DEFAULT_KEYS + NUM_DEFAULT_MGMT_KEYS +
	    NUM_DEFAULT_BEACON_KEYS) {
*		cfg80211_rx_unprot_mlme_mgmt@p(rx->sdata->dev, ...);
		...
	}
	...
}

@err_ieee80211_is_beacon@
identifier rx, fc, result;
position p;
@@

ieee80211_rx_h_decrypt(struct ieee80211_rx_data *rx)
{
	...
	if (unlikely(ieee80211_is_beacon(fc) && result == RX_DROP_UNUSABLE))
*		cfg80211_rx_unprot_mlme_mgmt@p(rx->sdata->dev, ...);
	...
}

@script:python depends on detect@
p << err_mmie_keyidx.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-42722')

@script:python depends on detect@
p << err_ieee80211_is_beacon.p;
@@

coccilib.report.print_report(p[0], 'ERROR: CVE-2022-42722')
